<?php
class Funnel_CPT {

	public static function init() {
		self::register_lead_cpt();
	}

	public static function register_lead_cpt() {
	    $labels = array(
	        'name'                  => _x( 'Leads', 'Post Type General Name', 'funnel' ),
	        'singular_name'         => _x( 'Lead', 'Post Type Singular Name', 'funnel' ),
	        'menu_name'             => __( 'Funnel', 'funnel' ),
	        'name_admin_bar'        => __( 'Leads', 'funnel' ),
	        'archives'              => __( 'List leads', 'funnel' ),
	        'attributes'            => __( 'Attributes', 'funnel' ),
	        'parent_item_colon'     => __( 'Lead parent:', 'funnel' ),
	        'all_items'             => __( 'Leads', 'funnel' ),
	        'add_new_item'          => __( 'Add new lead', 'funnel' ),
	        'add_new'               => __( 'Add new', 'funnel' ),
	        'new_item'              => __( 'New lead', 'funnel' ),
	        'edit_item'             => __( 'Edit lead', 'funnel' ),
	        'update_item'           => __( 'Update lead', 'funnel' ),
	        'view_item'             => __( 'View lead', 'funnel' ),
	        'view_items'            => __( 'View leads', 'funnel' ),
	        'search_items'          => __( 'Search lead', 'funnel' ),
	        'items_list'            => __( 'List leads', 'funnel' ),
	        'items_list_navigation' => __( 'List leads', 'funnel' ),
	        'filter_items_list'     => __( 'Filter leads', 'funnel' ),
	    );
	    
	    $rewrite = array(
	        'slug'                  => 'lead',
	        'with_front'            => true,
	        'pages'                 => false,
	        'feeds'                 => false,
	    );
	    
	    $args = array(
	        'label'                 => __( 'Lead', 'funnel' ),
	        'description'           => __( 'Lead', 'funnel' ),
	        'labels'                => $labels,
	        'supports'              => array( 'title', 'thumbnail' ),
	        'taxonomies'            => array(),
	        'hierarchical'          => false,
	        'public'                => true,
	        'show_ui'               => true,
	        'show_in_menu'          => true,
	        'menu_position'         => 70,
	        'menu_icon'             => 'dashicons-filter',
	        'show_in_admin_bar'     => true,
	        'show_in_nav_menus'     => true,
	        'can_export'            => true,
	        'has_archive'           => true,
	        'exclude_from_search'   => false,
	        'publicly_queryable'    => false,
	        'rewrite'               => $rewrite,
	        'capability_type'       => 'page',
	        'show_in_rest'          => true,
	    );

	    register_post_type( 'funnel_lead', $args );

	}
}
Funnel_CPT::init();
