<?php
class Funnel_Leads {
    
    public static function getLeadByUserId( $user_id ) {
        $leads = get_posts( array(
            'post_type'  => 'funnel_lead',
            'meta_key'   => 'user_id',
            'meta_value' => $user_id
        ) );
        if ( is_array($leads) ) {
            $lead = $leads[0];
        } else {
            $lead = null;
        }
        return $lead;
    }

    public static function addLead( $user_id ) {
        $lead = Funnel_leads::getLeadByUserId( $user_id );
        if ( $lead ) {
            return $lead->ID;
        } else {
            $user_data = get_userdata( $user_id );
            $lead_id = wp_insert_post(array (
                'post_type' => 'funnel_lead',
                'post_title' => $user_data->display_name,
                'post_status' => 'publish'
            ));
            if ($lead_id) {
                // user
                add_post_meta($lead_id, 'user_id', $user_id);
                return $lead_id;
            }
        }
        return 0;
    }

    public static function setState( $lead_id, $state ) {
        wp_set_post_terms( $lead_id, $state, 'funnel_state' );
    }
}