<?php
class Funnel_TAX {

	public static function init() {
		self::register_tax();
	}

	public static function register_tax() {
	    // States
	    $labels = array(
	        'name' => _x( 'States', 'funnel' ),
	        'singular_name' => _x( 'State', 'funnel' ),
	        'search_items' =>  __( 'Search States', 'funnel' ),
	        'popular_items' => __( 'Popular States', 'funnel' ),
	        'all_items' => __( 'All States', 'funnel' ),
	        'parent_item' => null,
	        'parent_item_colon' => null,
	        'edit_item' => __( 'Edit State', 'funnel' ),
	        'update_item' => __( 'Update State', 'funnel' ),
	        'add_new_item' => __( 'Add New State', 'funnel' ),
	        'new_item_name' => __( 'New State Name', 'funnel' ),
	        'separate_items_with_commas' => __( 'Separate states with commas', 'funnel' ),
	        'add_or_remove_items' => __( 'Add or remove states', 'funnel' ),
	        'choose_from_most_used' => __( 'Choose from the most used states', 'funnel' ),
	        'menu_name' => __( 'States', 'funnel' ),
	    );
	    register_taxonomy( 'funnel_state', 'funnel_lead', array(
	        'hierarchical'      => true,
	        'labels'            => $labels,
	        'show_ui'           => true,
	        'show_admin_column' => true,
	        'query_var'         => true,
	        'rewrite'           => array( 'slug' => 'state' ),
	        'meta_box_cb'       => array( __CLASS__, 'render_meta_box' ),
	    ));

	}
	
	public static function render_meta_box( $post ) {
	    $state_selected = wp_get_object_terms( $post->ID, 'funnel_state' );
	    
	    if ( sizeof( $state_selected ) ) {
	        $state_selected = $state_selected[0]->term_id;
	    } else {
	        $state_selected = '';
	    }
	    $states = get_terms(array( 'taxonomy' => 'funnel_state', 'hide_empty' => false) );
	    if ( !is_wp_error( $states ) ) {
	        /*
	        echo '<select name="tax_input[funnel_state][]" class="widefat">';
	        foreach ( $states as $state ) {
	            $selected = ($state_selected == $state->term_id) ? 'selected' : '';
	            echo '<option value="' . $state->term_id . '" ' . $selected . ' >' . $state->name . '</option>';
	        }
	        echo '</select>';
	        */
	        wp_dropdown_categories(array(
    	        'taxonomy' => 'funnel_state',
    	        'class' => 'widefat',
    	        'hide_empty' => 0,
    	        'name' => "tax_input[funnel_state][]",
	            'selected' => $state_selected,
    	        'orderby' => 'name',
    	        'hierarchical' => 1,
    	        'show_option_all' => " "
	        ));
	    }
	    
	}
}
Funnel_TAX::init();
