<?php
class Funnel_WP {
    
    public static function init() {
        add_action( 'user_register', array( __CLASS__, 'user_register' ), 10, 1 );
        
        // Page visited
        add_action( 'template_redirect', array( __CLASS__, 'wp_init' ) );
    }

    public static function user_register ( $user_id ) {
        if ( get_option('funnel_user_to_lead') ) {
            $user_data = get_userdata( $user_id );
            
            $lead_id = wp_insert_post(array (
                'post_type' => 'funnel_lead',
                'post_title' => $user_data->display_name,
                'post_status' => 'publish'
            ));
            if ($lead_id) {
                // user
                add_post_meta($lead_id, 'user_id', $user_id);
                // state
                $state = get_option( 'funnel_user_state' );
                if ( $state ) {
                    wp_set_post_terms( $lead_id, $state, 'funnel_state' );
                }
            }
        }
    }

    public static function wp_init() {
        global $post;
          
        // referrer?
        $referred = false;
        if ( get_option('funnel_referrer_enabled') ) {
            if ( is_user_logged_in() ) {
                if ( isset($_REQUEST[get_option('funnel_referrer_param')]) ) {
                    $lead = Funnel_leads::getLeadByUserId( get_current_user_id() );
                    if ( $lead ) {
                        wp_set_post_terms( $lead->ID, get_option( 'funnel_referrer_state' ), 'funnel_state' );
                        $referred = true;
                    }
                }
            }
        }
        
        // check if page visited by a logged user and referrer is not applied
        if ( !$referred ) {
            if ( is_user_logged_in() ) {
                $user_id = get_current_user_id();
                $state = get_post_meta($post->ID, 'funnel_user_state', true);
                            
                if ( $state && ( $state > 0 ) ) {
                    $lead = Funnel_leads::getLeadByUserId( $user_id );
                    if ( $lead ) {
                        wp_set_post_terms( $lead->ID, $state, 'funnel_state' );
                    }
                }
            }
        }
    }
}
Funnel_WP::init();